; Winrad HD / PM SDR Automation
;
; =============================================================================================================
; Impressum
; (C) Dr. Matthias Zwoch 2008
;
;    This script is freeware and is available for all hobbyists for free
;    Using this scrip is only on your own risk. Pay attention to the notes in the readme file
;    Matthias Zwoch is not taking any responsibility or obligations 
;    Spreading and modifications of this script are allowed as long as these are documented 
;    in this impression 
;    This file is an English translation (by Guido Schotmans) of the original German laguage 
;    script that is available on the web page of SSB-Electronics http://www.ssb.de.
;    Guido Schotmans made also some modifications to handle closing better and introduced some 
;    settings (WFall screen, 0.8 kHz Bandwidth and minimizing application) that will keep 
;    the CPU usage lower.
;
;	=================================================================================================
;
;	 APRIL 2010: Altered to support the PM SDR recording with WINRAD HD  by David Hamilton 
;	 with assistance from Ken Baird. 
;
;	 Remember this is written for a 1024 screens, with WINRAD HD in default c:/Program Files/Winrad
;
;	 Remember to copy "pskill.exe" into WINRAD HD folder
;
;	 Untested with different screen resolutions
;
;	 Reember to leave the PM SDR set at the desired frequency you wish to record
;
;	 Distributable Freely, but please leave these web links intact. Thank you. Ken, Scotland
;
;	 www.ayrshirehistory.eu/tadx
;
;	 http://band1tvdx.blogspot.com/
;       	     	
; 	===================================================================================================
;
;    Starttime, Stoptime, Spanwidth, and  destination folder determination
;    Times : your PC time ! (normally your LOCAL time)
;
;    Put together for Autohotkey Version 1.0.47.01 Download von www.autohotkey.com 
;    You will also need pskill.exe Download from http://download.sysinternals.com/Files/PsTools.zip
;
;---------------------------
;  Parameters
;---------------------------
Starttime := 1330  ;This is the Starttime in 4 figures only in your local time (PC time) 
Stoptime :=  1331      ;Stoptime, as above
Shutdown := "No"           ;Put here "Yes" or "No" for shutdown PC after recording. 
;
;
;---------------------------
;  Constants, edit these 
;  to fit with your system
;---------------------------
;
ToRun := "C:\Program Files\WinradHD\WinradHD.exe"  ;This is the WINRADHD Directory
WorkDir := "C:\Program Files\WinradHD"         ;This is the Work Directory, otherwise it will not find the files
PsKill := "C:\Program Files\WinradHD\pskill.exe -t Winrad.exe /accepteula"   ;To kill hanging winrad processes
;
;---------------------------
;  Initialising
;---------------------------
;
; Arbeitsverzeichnis fr abzulegende Dateien im Wurzelverzeichnis aufbauen
; Winrad.exe vertrgt keine _ im vorgegebenem Dateinamen, daher hssliche Trennung mit "x"
;
SetDefaultMouseSpeed,10
FileDir = %BaseDir%\%A_YYYY%.%A_MM%.%A_DD%
;
;---------------------------
;  General program
;---------------------------
;
gosub,WaitForStart       ;Wait untill the Start Time is reached
gosub,StartWinrad       ;Start and control the sdr
gosub,WaitForEnd         ;wating for End time during recording
gosub,StopWinrad        ;Stop Winrad 
gosub,GoSleep            ;This is the Close Script and will shut down the PC when needed
;
;
;---------------------------
;  Subroutine WaitForStart
;---------------------------
;
;
;  Waiting 
WaitForStart:
loop
{
  CurTime := (A_hour*100)+A_min    ;Putting together the local PC time in four digits
  if (CurTime = Starttime)         ;Is this the Starting Time
  {
    break                          ;Then it will start
  }
  sleep,15000                      ;otherwise wait for 15 sec and check again
}    
return
;
;---------------------------
;  Subroutine StartWinrad
;  Starts the recording and
;  "controls" the Winrad
;---------------------------
;
StartWinrad:
; This will create a new Work Directory
run,cmd                            ;opening the DOS Shell
sleep,2000                         ;Wait untill it can be used
send mkdir {"}%Filedir%{"}{Enter}  ;Send mkdir Command
sleep,1000                         ;Wait 1 second
send exit{Enter}                   ;close DOS Shell
;This will kill still hanging Winrad.exe Zombies 
run,%PsKill%
sleep,2000
run,%ToRun%,%WorkDir%              ;Call WinradHD.exe 
sleep,5000                         ;Wait untill initialising end
MouseClick,,60,609,                ;select 2nd window
sleep,1500
MouseClick,,193,424,                ;select 3rd window
sleep,1500                          ;Wait half a second
MouseClick,,350,461,                ;select 4th window
MouseClick,,670,312,                ;minimse window
sleep,1500                          ;Wait half a second
MouseClick,,56,682,                ;start
sleep,1500                          ;Wait half a second
MouseClick,,163,564,                ;record
sleep,500                          ;Wait half a second


return                             ;
;
;---------------------------
;  Subroutine WaitForEnd
;  Waiting for the StopTime 
;  of the recording
;---------------------------
;
WaitForEnd:
loop
{
  CurTime := (A_hour*100)+A_min    ;Current Time in 4 digit format
  if (CurTime = Stoptime)          ;Is this the Stop Time ?
  {
    break                          ;If yes then execute it
  } 
  sleep,15000                      ;otherwise wait again for recording end.
}    
return
;
;---------------------------
;  Subroutine StopWinrad
;  This will stop the recording
;  and closes WinradHD.exe
;---------------------------
;
StopWinrad:
WinMaximize,Winrad                ;Unminimize Winrad to make it able to use it.
sleep,2000                         ;Wait 2 seconds
MouseClick,,297,560,                 ;Click RecorderStop Button
sleep,1000                         ;Wait 1 second 
MouseClick,,58,750,               ;Close winrad by exit button
sleep,2000                         ;Wait 2 seconds
WinClose,Winrad                   ;Send a closing command too, to be sure
sleep,3000                         ;Wait 3 seconds
run,%PsKill%                       ;Kill hanging Winrad processes
return
;
;---------------------------
;  Subroutine GoSleep
;  This will close the running script and wait for the next one
;  or it will shutdown the PC
;---------------------------
;
;
GoSleep:
if (Shutdown = "Yes")
{
  sleep 3000
  shutdown,1                        ;Try to shutdown softly
  sleep 30000                       ;Still there ?
  shutdown,9                        ;Force a shutdown
}
exit  
return                              ;
